#include "signal_emitter.h"
#include <QThreadPool>
#include <QRunnable>
#include <iostream>

class ATask : public QRunnable
{
  void run()
  {
    for(int i = 0; i < 10; ++i) {
      std::cout << "counting in thread: " << i << '\n';
      QThread::sleep(1);
    }
  }
};


signal_emitter::signal_emitter(QObject *parent) :
  QObject(parent)
{
}

void signal_emitter::launch()
{
  std::cout << "Hello, world!\n";

  ATask *atask = new ATask();
  QThreadPool::globalInstance()->start(atask);
  //QThreadPool::globalInstance()->waitForDone();

  for(int i = 0; i < 10 ; ++i) {
    emit send(i);
    QThread::sleep(1);
  }

  emit finished();
}
